package business;

import util.Jsonable;

public class City implements Comparable<City>, Jsonable{

	private final String name;
	private final String code;
	private final String department;
	private final String inseeCode;

	public City(String name, String code, String department, String inseeCode) {
		this.name = name;
		this.code = code;
		this.department = department;
		this.inseeCode = inseeCode;
	}
	
	public String toJson(){
		return "{name:'" + name + "', department:'" + department + "', " +
				"code:" + code + ", inseeCode:" + inseeCode +"}";
	}

	public String getName() {
		return name;
	}

	public String getCode() {
		return code;
	}

	public String getDepartment() {
		return department;
	}

	public String getInseeCode() {
		return inseeCode;
	}

	public int compareTo(City other) {
		return getName().compareTo(other.getName());
	}
}
