package business;

import java.net.URI;
import java.util.HashMap;
import java.util.Map;

import com.sun.net.httpserver.HttpExchange;

public class HttpParameters {
	private Map<String, String> parameters = new HashMap<String, String>();

	public HttpParameters(HttpExchange exchange) {
		URI url = exchange.getRequestURI();
		String query = url.getQuery();
		if (query.length() > 0){
			String[] pairs = query.split("&");
			for(String pair : pairs){
				String[] info = pair.split("=");
				parameters.put(info[0], info[1]);
			}
		}
	}
	public String get(String paramName){
		return parameters.get(paramName);
	}
	public int getInt(String paramName){
		return Integer.parseInt(parameters.get(paramName));
	}
	public <T extends Enum<T>> T getEnum(Class<T> enumType, String paramName){
		return Enum.valueOf(enumType, parameters.get(paramName));
	}
}
