package business;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class Insee {

	public static Insee instance = new Insee();

	private List<City> cities = new ArrayList<City>();
	
	private Insee() {
		try {
			BufferedReader in = new BufferedReader
				(new InputStreamReader
						(new BufferedInputStream
								(getClass().getResourceAsStream("/data/Insee.csv"))));
			String line;
			while ((line = in.readLine()) != null) {
				String[] infos = line.split(";");
				cities.add(new City(infos[0], infos[1], infos[2], infos[3]));
			}
			Collections.sort(cities);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public List<City> getCitiesStartingBy(String namePrefix, int nbMax) {
		namePrefix = namePrefix
			.replace("é", "e").replace("è", "e").replace("ê", "e").replace("à", "a")
			.replace("ù", "u").replace("û", "u").replace("ô", "o").toUpperCase();
		List<City> matched = new ArrayList<City>();
		for(City c : cities){
			if (c.getName().startsWith(namePrefix)){
				matched.add(c);
				if (--nbMax == 0){
					break;
				}
			}
		}
		return matched;
	}

	public City getCity(String inseeCode) {
		City res = null;
		for(City c : cities){
			if (c.getInseeCode().equals(inseeCode)){
				res = c;
				break;
			}
		}
		return res;
	}

	public City getCity(String name, String code) {
		City res = null;
		for(City c : cities){
			if (c.getName().equals(name) && c.getCode().equals(code)){
				res = c;
				break;
			}
		}
		return res;
	}
}
