package business.publishers;

import java.util.ArrayList;
import java.util.List;

import business.Ad;
import business.City;
import business.Kind;

public abstract class Publisher {
	protected int nbPages;

	protected abstract List<Ad> findAds(Kind kind, City city, int minPrice, int maxPrice, int minArea, int maxArea,
			int i);

	public List<Ad> findAds(final Kind kind, final City city, final int minPrice, final int maxPrice,
			final int minArea, final int maxArea) {
		try {

			final List<Ad> ads = new ArrayList<Ad>();
			ads.addAll(findAds(kind, city, minPrice, maxPrice, minArea, maxArea, 1));

			// Iterate over every page
			List<Thread> threads = new ArrayList<Thread>();
			for (int i = 2; i < nbPages; i++) { // nbPages is now set
				final int index = i;
				threads.add(new Thread() {
					@Override
					public void run() {
						List<Ad> newAds = findAds(kind, city, minPrice, maxPrice, minArea, maxArea, index);
						synchronized (ads) {
							ads.addAll(newAds);
						}
					}
				});
			}
			for (Thread t : threads)
				t.start();
			for (Thread t : threads)
				t.join();
			return ads;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
}
