function AutoComplete(form, textbox, panel, url, displayFct){
	this.form = $(form)
	this.textbox = $(textbox)
	this.panel = $(panel)
	this.url = url
	this.displayFct = displayFct
	
	var me = this // Capture because this will be something else in the fct

	me.clearSuggestions = function(){
		me.panel.update("")
	}
	
	me.getSelectedIndex = function(){
		var selectedIndex = -1
		var nodes = me.panel.childNodes 
		for(var i in nodes){
			if (nodes[i].className && nodes[i].className.indexOf("selected") > -1){
				selectedIndex = i
				break
			}
		}
		return selectedIndex
	}
	
	me.textbox.onkeypress = function(event){
		var key = getKeyCode(event)

		if (me.panel.innerHTML != "" &&
			(key == Event.KEY_RETURN || key == Event.KEY_TAB)){
			var selectedIndex = me.getSelectedIndex()
			if (selectedIndex > -1){
				me.textbox.value = me.panel.childNodes[selectedIndex].firstChild.data
				me.clearSuggestions()
				me.textbox.focus()
			}
			return false // stop event
		}
	}
	
	me.textbox.onkeyup = function(event){
		var key = getKeyCode(event)
		if (key == Event.KEY_RETURN) return false // don't listen to RETURN here. Stop event
		
		if (key == Event.KEY_DOWN || key == Event.KEY_UP){
			var selectedIndex = me.getSelectedIndex()
			var nodes = me.panel.childNodes 
			if (selectedIndex > -1){
				nodes[selectedIndex].className = ""
			}
			if (key == Event.KEY_DOWN && selectedIndex < nodes.length - 1){
				selectedIndex++
			}
			if (key == Event.KEY_UP && selectedIndex > 0){
				selectedIndex--
			}
			Element.addClassName(nodes[selectedIndex], "selected")
		} else {
			new Ajax.Request(me.url, {
				method: "get",
				parameters: me.form.serialize(true),
				onSuccess: function (transport){
					var json = eval('(' + transport.responseText + ')');
					me.clearSuggestions()
					if (json.length == 1){
						me.textbox.value = me.displayFct(json[0])
					} else if (json.length > 1){
						json.each(function(item){
							var text = me.displayFct(item)
							var div = document.createElement("div")
							Element.update(div, text)
							div.onmousedown = function() {
								me.textbox.value = text
								me.clearSuggestions()
							}
							me.panel.appendChild(div)
						})
					}
				}
			})
		}
		return false // stop event
	}
}
