package gui;

import http.Server;

import java.awt.Image;
import java.awt.MenuItem;
import java.awt.PopupMenu;
import java.awt.SystemTray;
import java.awt.Toolkit;
import java.awt.TrayIcon;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import business.ImmoServer;

public class EntryPoint {
	private Server server;

	public EntryPoint() {
		if (!SystemTray.isSupported()) {
			throw new RuntimeException("Version de Java Obsolete");
		}
		try {
			PopupMenu popup = new PopupMenu();
			MenuItem mnuOpen = new MenuItem("Ouvrir");
			mnuOpen.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
//					trayIcon.displayMessage("Titre", "Informations...", TrayIcon.MessageType.INFO);
					openBrowser();
				}
			});
			popup.add(mnuOpen);

			popup.add(new MenuItem("-"));

			MenuItem mnuQuit = new MenuItem("Quitter");
			mnuQuit.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					server.stop();
					System.exit(0);
				}
			});
			popup.add(mnuQuit);

			Image image = Toolkit.getDefaultToolkit().getImage(getClass().getResource("/data/logeo.jpg"));
			final TrayIcon trayIcon = new TrayIcon(image, "Logeo", popup);
			trayIcon.setImageAutoSize(true);
			SystemTray.getSystemTray().add(trayIcon);
			server = new ImmoServer();
			server.start();
			openBrowser();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void openBrowser() {
		StartBrowser.openURL("http://localhost:2001");
	}

	public static void main(String[] args) {
		new EntryPoint();
	}
}
