package http;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;

public class Client {
	public static StringBuilder get(String url){
		return getContent(url, "GET");
	}
	public static StringBuilder post(String url){
		return getContent(url, "POST");
	}
	private static StringBuilder getContent(String url, String method) {
		StringBuilder sb = new StringBuilder();
		try {
			HttpURLConnection cnx = (HttpURLConnection) new URL(url).openConnection();
			cnx.setRequestMethod(method);
			if (cnx.getResponseCode() == 200){
				BufferedReader res = new BufferedReader(new InputStreamReader(cnx.getInputStream()));
				String line;
				while ((line = res.readLine()) != null){
					sb.append(line);
					sb.append("\n");
				}
				res.close();
			}
			cnx.disconnect();
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		return sb;
	}
}
