﻿import Domaine;
import HttpClient;
import std.string, std.file;
import std.regexp;
import std.stream;
import std.conv;

public class LogicImmo {
    public char[] Nom = "Logic-Immo";

    private int nbPages;
    private int nbPage = 1;

    private RegExp nettoyageRe;
    private RegExp annoncesRe;
	private RegExp nbPagesRe;
	
    this(){
        nettoyageRe = RegExp(
			`(<!-- Prix du bien en francs.*</span>)` // prix francs
			~ `|(Référence : LOGIC .*)</span>` 
			~ `|(Envoyer à un ami)` 
			~ `|(&gt;&gt; Plus de détails)` 
			~ `|(&nbsp;.+ photos?)` // nombre de photos
			~ `|bgcolor="#f6f6f6"` // tableau gris
			~ `|width=".+"` // tableau gris			
			, "gi"
		);
		annoncesRe = RegExp(`<!-- HEADER //-->(.*)<!-- SEPARATOR //-->`, "gi");
		nbPagesRe = RegExp(`<td align="right" width="15%">page (.*)/(.*)</td>`, "gi");
    }

    public Annonce[] getAnnonces(TypeBien typeBien, Ville ville, int prixMin, int prixMax, int surfaceMin, int surfaceMax) {		
        Http requete = new Http("http://www.logic-immo.com/ventes/page-resultat.php?type_bien_0={typeBien}&nb_pieces_min=0&nb_pieces_max=0&prix_min={pxMin}&prix_max={pxMax}&surface_min={surfMin}&surface_max={surfMax}&recherche=avancee&localisations={cp}&pays=fr&univers=2&nb_type_bien=17&num_page={page}&btnEnvoi.x=37&btnEnvoi.y=14");
        requete["typeBien"] = (typeBien == TypeBien.Appartement ? "app" : "mai");
        requete["pxMin"] = std.string.toString(prixMin);
        requete["pxMax"] = std.string.toString(prixMax);
        requete["surfMin"] = std.string.toString(surfaceMin);
        requete["surfMax"] = std.string.toString(surfaceMax);
        requete["cp"] = ville.codePostal;
        requete["page"] = std.string.toString(nbPage);
        char[] html = requete.get();

        html = replace(html, "\r", " ")	;
        html = replace(html, "\n", " ");
		
		// Récupération du numéro de page
        if (nbPages == 0) {
			if (nbPagesRe.find(html) > -1){
				nbPages = toInt(nbPagesRe.match(2)); // tout, puis page, puis nbpages
			} else {
				nbPages = 1;
			}
        }
		
    	html = nettoyageRe.replace(html, "");
        html = html.replace("<img src=\"/", "<img src=\"http://www.logic-immo.com/");
        html = html.replace(`<a href="/`, `<a href="http://www.logic-immo.com/`);
		
        // Nettoyer images
        html = sub(html, "<img .*>",
               delegate char[] (RegExp m){ return std.string.find(m.match(0), "http://images.logicimmo.com") > -1 ? m.match(0) : "";}, "gi");

        // Extraction des annonces seulement
		Annonce[] annonces;
        foreach (m; annoncesRe.search(html)) {
            annonces ~= new Annonce(m.match(1));
        }
        
        // Itération sur toutes les pages
        if (nbPage++ < nbPages) { 
            annonces ~= getAnnonces(typeBien, ville, prixMin, prixMax, surfaceMin, surfaceMax);
			append("d:/log.txt", "nb page ++");
        }

        return annonces;
    }
}

//~ void main(){
	//~ auto moteur = new LogicImmo();
	//~ //Ville ville = new Ville("BIDACHE", "64520", "PYRENEES ATLANTIQUES", "64123");
	//~ Ville ville = new Ville("CESSON", "77240", "SEINE ET MARNE", "77067");

	//~ Annonce[] annonces = moteur.getAnnonces(TypeBien.Maison, ville, 200000, 250000, 70, 200);
	//~ printf("%d annonces", annonces.length);
	//~ write("annonces.html", "annonces logic immo");
	//~ foreach(a; annonces){
		//~ append("annonces.html", a.html);
		//~ append("annonces.html", "\n");
	//~ }

//~ }